﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Forms;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using PhotoViewer.Utilities;

namespace PhotoViewer
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private PhotoCollection photos;

        public MainWindow()
        {
            InitializeComponent();
            photos = new PhotoCollection(Environment.CurrentDirectory + "\\images");
        }

        public PhotoCollection Photos
        {
            get
            {
                return this.photos;
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            using (FolderBrowserDialog folderBrowser = new FolderBrowserDialog())
            {
                folderBrowser.ShowNewFolderButton = false;
                if (Directory.Exists(this.photos.Path))
                {
                    folderBrowser.SelectedPath = this.photos.Path;
                }

                if (folderBrowser.ShowDialog(this) == System.Windows.Forms.DialogResult.OK)
                {
                    this.photos.Path = folderBrowser.SelectedPath;
                }
            }

            e.Handled = true;
        }
    }
}
