﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Controls;
using System.Globalization;
using System.Text.RegularExpressions;

namespace AddressBook
{
    class PhoneNumberValidationRule : ValidationRule
    {
        public override ValidationResult Validate(object value, CultureInfo cultureInfo)
        {
            string stringValue = value.ToString();
            string pattern = @"^(\+?\d+)\s\(\d{3}\)\s(\w{7}|\w{3}\-\w{4})(\s[xX]\w+)?$";

            if (String.IsNullOrWhiteSpace(stringValue) || Regex.IsMatch(stringValue, pattern))
            {
                return ValidationResult.ValidResult;
            }
            else
            {
                return new ValidationResult(false, "Value is not a valid phone number.");
            }
        }
    }

    class EmptyStringValidationRule : ValidationRule
    {
        public override ValidationResult Validate(object value, CultureInfo cultureInfo)
        {
            string stringValue = value.ToString();
            if (String.IsNullOrWhiteSpace(stringValue))
            {
                return new ValidationResult(false, "Value is an empty string.");
            }
            else
            {
                return ValidationResult.ValidResult;
            }
        }
    }
}
