﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows;

namespace PhotoViewer.Utilities
{
    public static class WPFInteropExtensions
    {
        public static DialogResult ShowDialog(this Form form, Window owner)
        {
            Shim shim = new Shim(owner);
            return form.ShowDialog(shim);
        }

        public static DialogResult ShowDialog(this CommonDialog commonDialog, Window owner)
        {
            Shim shim = new Shim(owner);
            return commonDialog.ShowDialog(shim);
        }

        class Shim : IWin32Window
        {
            private System.Windows.Interop.WindowInteropHelper interopHelper;

            // Create a WindowInteropHelper for the WPF Window
            public Shim(Window owner)
            {
                interopHelper = new System.Windows.Interop.WindowInteropHelper(owner);
            }

            // Return the surrogate handle
            public IntPtr Handle
            {
                get
                {
                    return interopHelper.Handle;
                }
            }
        }
    }
}
