﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;

namespace PublishAndRaise
{
    public class Contact
    {
        public event EventHandler<AddressChangedEventArgs> AddressChanged;
        public event EventHandler<AddressChangingEventArgs> AddressChanging;

        private string address;

        protected virtual void OnAddressChanged(AddressChangedEventArgs e)
        {
            EventHandler<AddressChangedEventArgs> handler = AddressChanged;
            if (handler != null)
            {
                handler(this, e);
            }
        }

        protected virtual void OnAddressChanging(AddressChangingEventArgs e)
        {
            EventHandler<AddressChangingEventArgs> handler = AddressChanging;
            if (handler != null)
            {
                handler(this, e);
            }
        }

        public string Address
        {
            get { return this.address; }
            set
            {
                AddressChangingEventArgs args = new AddressChangingEventArgs(value);
                OnAddressChanging(args);
                if (!args.Cancel)
                {
                    string oldAddress = this.address;
                    this.address = value;
                    AddressChangedEventArgs e = new AddressChangedEventArgs(oldAddress, this.address);
                    OnAddressChanged(e);
                }
            }
        }
    }
}
