﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace JumpStatements
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void buttonGenerate_Click(object sender, EventArgs e)
        {
            this.textBoxBreakOutput.Clear();

            if (this.radioButtonBreakDoStatement.Checked)
            {
                PowersOfTwoBreakDoLoop(this.numericUpDownBreakAfter.Value);
            }
            else if (this.radioButtonBreakWhileStatement.Checked)
            {
                PowersOfTwoBreakWhileLoop(this.numericUpDownBreakAfter.Value);
            }
            else if (this.radioButtonBreakForStatement.Checked)
            {
                PowersOfTwoBreakForLoop(this.numericUpDownBreakAfter.Value);
            }
            else if (this.radioButtonBreakForeachStatement.Checked)
            {
                PowersOfTwoBreakForeachLoop(this.numericUpDownBreakAfter.Value);
            }
            else
            {
                MessageBox.Show("Please choose an iteration statement.");
            }
        }

        private void buttonContinueGenerate_Click(object sender, EventArgs e)
        {
            this.textBoxBreakOutput.Clear();

            if (this.radioButtonContinueDoStatement.Checked)
            {
                PowersOfTwoContinueDoLoop(this.numericUpDownContinue.Value);
            }
            else if (this.radioButtonContinueWhileStatement.Checked)
            {
                PowersOfTwoContinueWhileLoop(this.numericUpDownContinue.Value);
            }
            else if (this.radioButtonContinueForStatement.Checked)
            {
                PowersOfTwoContinueForLoop(this.numericUpDownContinue.Value);
            }
            else if (this.radioButtonContinueForeachStatement.Checked)
            {
                PowersOfTwoContinueForeachLoop(this.numericUpDownContinue.Value);
            }
            else
            {
                MessageBox.Show("Please choose an iteration statement.");
            }
        }

        private void PowersOfTwoBreakForeachLoop(decimal breakAfter)
        {
            int[] values = Enumerable.Range(0, 101).ToArray();
            foreach (int i in values)
            {
                this.textBoxBreakOutput.AppendText(String.Format("{0}^2 = {1}\r\n", i, Math.Pow(i, 2)));
            }
        }

        private void PowersOfTwoBreakForLoop(decimal breakAfter)
        {
            for (int i = 0; i <= 100; i++)
            {
                this.textBoxBreakOutput.AppendText(String.Format("{0}^2 = {1}\r\n", i, Math.Pow(i, 2)));
            }
        }

        private void PowersOfTwoBreakWhileLoop(decimal breakAfter)
        {
            int i = 0;
            while (i <= 100)
            {
                this.textBoxBreakOutput.AppendText(String.Format("{0}^2 = {1}\r\n", i, Math.Pow(i, 2)));
                i++;
            }
        }

        private void PowersOfTwoBreakDoLoop(decimal breakAfter)
        {
            int i = 0;
            do
            {
                this.textBoxBreakOutput.AppendText(String.Format("{0}^2 = {1}\r\n", i, Math.Pow(i, 2)));
                i++;
            }
            while (i <= 100);
        }

        private void PowersOfTwoContinueForeachLoop(decimal skip)
        {
            int[] values = Enumerable.Range(0, 101).ToArray();
            foreach (int i in values)
            {
               this.textBoxBreakOutput.AppendText(String.Format("{0}^2 = {1}\r\n", i, Math.Pow(i, 2)));
            }
        }

        private void PowersOfTwoContinueForLoop(decimal skip)
        {
            for (int i = 0; i <= 100; i++)
            {
                this.textBoxBreakOutput.AppendText(String.Format("{0}^2 = {1}\r\n", i, Math.Pow(i, 2)));
            }
        }

        private void PowersOfTwoContinueWhileLoop(decimal skip)
        {
            int i = 0;
            while (i <= 100)
            {
                this.textBoxBreakOutput.AppendText(String.Format("{0}^2 = {1}\r\n", i, Math.Pow(i, 2)));
                i++;
            }
        }

        private void PowersOfTwoContinueDoLoop(decimal skip)
        {
            int i = 0;
            do
            {
                this.textBoxBreakOutput.AppendText(String.Format("{0}^2 = {1}\r\n", i, Math.Pow(i, 2)));
                i++;
            }
            while (i <= 100);
        }
    }
}
