﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace AddressBook.Xfn
{
    public struct XfnRelationships
    {
        public Friendship Friendship { get; set; }
        public Geographic Geographic { get; set; }
        public Romantic Romantic { get; set; }
        public Family Family { get; set; }
        public Professional Professional { get; set; }

        public bool Me { get; set; }
        public bool Met { get; set; }

        public IEnumerable<string> Values
        {
            get
            {
                if (this.Friendship != Xfn.Friendship.None)
                {
                    yield return this.Friendship.ToString("g");
                }

                if (this.Geographic != Xfn.Geographic.None)
                {
                    yield return this.Geographic.ToString("g");
                }

                if (this.Family != Xfn.Family.None)
                {
                    yield return this.Family.ToString("g");
                }

                if (this.Professional != Xfn.Professional.None)
                {
                    foreach (Enum value in Enum.GetValues(typeof(Xfn.Professional)))
                    {
                        if (this.Professional.HasFlag(value))
                        {
                            yield return value.ToString("g");
                        }
                    }
                }

                if (this.Romantic != Xfn.Romantic.None)
                {
                    foreach (Enum value in Enum.GetValues(typeof(Xfn.Romantic)))
                    {
                        if (this.Romantic.HasFlag(value))
                        {
                            yield return value.ToString("g");
                        }
                    }
                }

                if (this.Me)
                {
                    yield return "Me";
                }

                if (this.Met)
                {
                    yield return "Met";
                }
            }
        }

        public override string ToString()
        {
             return String.Join(" ", this.Values);
        }
    }
}
