﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;

namespace AddressBook
{
    public struct PhoneNumber
    {
        public int CountryCode { get; set; }
        public int AreaCode { get; set; }
        public string SubscriberNumber { get; set; }
        public string Extension { get; set; }

        public override string ToString()
        {
            StringBuilder builder = new StringBuilder();
            if (this.CountryCode > 0)
            {
                builder.AppendFormat("+{0} ", this.CountryCode);
            }

            builder.AppendFormat("({0}) {1}", this.AreaCode, this.SubscriberNumber);

            if (!String.IsNullOrWhiteSpace(this.Extension))
            {
                builder.AppendFormat("x{0}", this.Extension);
            }

            return builder.ToString();
        }
    }
}
