using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;

namespace PhotoViewer
{
    public class PhotoCollection : ObservableCollection<IPhoto>
    {
        private string directory;

        public PhotoCollection(string directory)
            : base()
        {
            this.Path = directory;
        }

        public string Path
        { 
           get
           {
              return this.directory;
           }
           set
           {
               if (value == null)
               {
                   throw new ArgumentNullException("value");
               }

               if (String.IsNullOrWhiteSpace(value))
               {
                   throw new ArgumentException();
               }

              this.directory = value;
           }
        }
    }
}
